<?php

namespace App\Repositories\Models\CMS;

use App\Repositories\Models\Base\Resource;
use Carbon\Carbon;
use Illuminate\Database\Eloquent\Model;
use Prettus\Repository\Contracts\Transformable;
use Prettus\Repository\Traits\TransformableTrait;

/**
 * Class Banner.
 *
 * @package namespace App\Repositories\Models\CMS;
 */
class Banner extends Model implements Transformable
{
    use TransformableTrait;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $table = 'cms_banners';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [];

    protected $casts = ['click_body' => 'array'];

    protected static function booted()
    {
        static::saving(function (Banner $banner) {
            if (empty($banner->start_time)) {
                $banner->start_time = Carbon::now()->toDateTimeString();
            }
        });
    }

    public function cover_resource()
    {
        return $this->belongsTo(Resource::class, 'cover', 'id')->select(['id', 'url', 'path']);
    }

}
