<?php

namespace App\Repositories\Models\Course;

use App\Repositories\Models\Model;
use App\Repositories\Models\Base\Resource;
use Prettus\Repository\Contracts\Transformable;
use Prettus\Repository\Traits\TransformableTrait;

/**
 * Class Course.
 *
 * @package namespace App\Repositories\Models;
 */
class Course extends Model implements Transformable
{
    use TransformableTrait;

    protected $table = 'course_courses';


    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
//    protected $fillable = [
//        'category_id',
//        'title',
//        'type',
//        'labels',
//        'thumb',
//        'short_description',
//        'description',
//        'published_at',
//        'is_rec',
//        'comment_status',
//        'status',
//    ];
    protected $guarded = [];

    public function category()
    {
        return $this->belongsTo(Category::class, 'category_id', 'id');
    }

    public function thumb_resource()
    {
        return $this->belongsTo(Resource::class, 'thumb', 'id')->select(['path', 'id', 'url']);
    }

    public function attaches()
    {
        return $this->hasMany(Attach::class, 'course_id', 'id');
    }

    public function subscribe()
    {
        return $this->hasOne(UserRecord::class);
    }

    public function comments()
    {
        return $this->hasMany(Comment::class);
    }
}
